# Week 10 - Server & Client

This week we went over how to build a simple API server with the Express framework, and how to consume that API from a third-party web page. To run the code examples, go into `week9/server` and run `npm install express` (don't forget this) then `node server.js`.

When the server is running, you can open `week9/client` to play with the API. Read through the code carefully and try to get a grasp of how the client side JavaScript is communicating with server side JavaScript. If you are curious, don't hesitate to Google around on any term that you don't quite understand. (things like HTTP protocol, RESTful API, JSONP, etc.)

## The Assignment

1. Groupwork.

    You should pair up, or you can form groups of three if numbers are not even. At least you should be looking at another persons API homework from last week. Read each other's documentation page, and see if you can understand what this API does and how to use it. Provide honest feedback to each other, then improve your API based on this week's code. Also revise your documentation. Iterate until the other person can understand and actually use your API.

2. Individual work.

    Once completed step 1, take your partner's API and build a client side page using that API. Don't stop at merely showing basic data - build an actual page, style it, make it look legit.

## NOTES

1. You can use [this issue](https://github.com/yyx990803/creative-html5/issues/6) to look for group partners.

2. Next class you will present your work in groups. Be prepared to talk about what you went through to understand each other's API, and demonstrate your client side pages.

3. Final deliverable due after the presentation, at midnight:

- Improved API
- Revised Documentation
- Client page using another person's API

## About the final project

The final project will be very open ended - the main requirement is that the things we learned in this class must constitute a significant part of the project. Pick the building blocks that work for you: canvas animations, CSS3 transitions, using APIs, and the interactivity stuff we will soon cover. We will talk about it more next week, but start thinking about it now.