# Week 2 - JavaScript Fundamentals & Intro to Canvas API

## Assignment

### 1. Visual Piece

Create a visual composition with the Canvas API. You must use all the stuff we talked about in class:

- Rectangle
- Circle
- Line
- Linear Gradient (Radial Gradient is similar)
- Image
- Text (I forgot about this in class, but you can find the example in week2/code/canvas)

The composition must have a visual theme, not just a random collage. Think of it as designing a poster with JavaScript. Also think about the possibilities of the elements being animated in future revisions - we will do that as we learn more about programmatic animation.

If you already know how to do animation and mouse interactions - hold on with that and focus on creating interesting static compositions. (hint: you can combine for loops and Math.random() for a generative process.)

Bonus points:

1. Figure out how to use context matrix transform to rotate things in canvas and use it in your composition.

2. Explore drawing complex paths combining moveTo(), lineTo() and arc()

**How to submit**

Since most of you don't know how to push stuff to GitHub yet, please zip your files and name it "yourFirstName_week2.zip" then send to my newschool email address.

If you know how to push to github though, you are encouraged to do that and just send me the link to your repo. Ideally, keep all class projects in the same repo unless they are too big to sit with each other.

### 2. Git

Follow this <a href="https://github.com/yyx990803/creative-html5/blob/master/GIT.md" target="_blank">guide</a> on cloning this repo to your Mac with git.

### 3. JavaScript [Optional]

I know I'm going quite fast about JavaScript concepts in class. I want to leave us more time to actually make stuff, however it is important for you to understand these building blocks to be able to make cool stuff. So, if you feel lost about a certain slide, I strongly recommend you type the example code into the console or test it out in a blank HTML page with `console.log()`. **The only way to fully understand a programming concept is to write and test it yourself.**

### Resources

- <a href="http://www.nihilogic.dk/labs/canvas_sheet/HTML5_Canvas_Cheat_Sheet.pdf" target="_blank">Canvas Cheatsheet</a>
- <a href="https://developer.mozilla.org/en-US/docs/HTML/Canvas/Drawing_Graphics_with_Canvas" target="_blank">More canvas example code on MDN</a>
